#include <a4testing.hpp>

#include <sq3/config.hpp>




namespace sq3 {
namespace {



void
CheckLibVersion ()
{ // this is mostly to check the automated cmake generated config file
  BOOST_CHECK( sq3::MAJOR_VERSION == 0 );
    BOOST_CHECK( sq3::MINOR_VERSION == 1 );
    BOOST_CHECK( sq3::PATCH_VERSION == 0 );
} //----------------------------------------------------------------------------

void
CheckSqliteVersion ()
{
  BOOST_WARN_MESSAGE(build_internal_sqlite3, "not build_internal_sqlite3");

  if(build_internal_sqlite3)
    {
      using namespace sq3;
      BOOST_CHECK_EQUAL(
          sqliteCompiledVersion() , sqliteRuntimeVersion()
      );

      BOOST_CHECK(
          sqliteCompiledVersionNumber() == sqliteRuntimeVersionNumber()
      );
    }

} //--------------------------------------------------------------------------

//  assert( sqlite3_libversion_number()==SQLITE_VERSION_NUMBER );
//  assert( strcmp(sqlite3_sourceid(),SQLITE_SOURCE_ID)==0 );
//  assert( strcmp(sqlite3_libversion(),SQLITE_VERSION)==0 );


// ./sq3basics --on=config --log_level=all --run_test=whatever

a4TestAdd(
  a4test::suite("ConfigSuite")
  .addTest("check version", CheckLibVersion)
  .addTest("check version", CheckSqliteVersion)

) ;


}
}

