#include <a4testing.hpp>

#include <sq3/dbvalue.hpp>
#include <sq3/error.hpp>


using namespace sq3;

namespace sq3 {
namespace {
  
  
void 
General()
{
  DbValues r1( { DbValue(1)} );
  DbValues r2( { DbValue(1),DbValue("a")} );
  DbValues r3( { DbValue(2),DbValue("b")} );

  BOOST_CHECK_THROW(r1 = r2, ErrTypeMisMatch );

  BOOST_CHECK(r2.at (0).getInt () != r3.at (0).getInt ());
  BOOST_CHECK(r2.at (1).getText () != r3.at (1).getText ());

  BOOST_CHECK_NO_THROW(r2 = r3);

  BOOST_CHECK(r2.at (0).getInt () == r3.at (0).getInt ());
  BOOST_CHECK(r2.at (1).getText () == r3.at (1).getText ());

  DbValues r4( { DbValue(2),DbValue("b")} );

  BOOST_CHECK_THROW(r4 = std::move(r1), ErrTypeMisMatch );

  BOOST_CHECK_NO_THROW(r4 = std::move(r3));

  BOOST_CHECK(r2.at (0).getInt () == r4.at (0).getInt ());
  BOOST_CHECK(r2.at (1).getText () == r4.at (1).getText ());



}



a4TestAdd(
  a4test::suite("dbvalrow")
  .addTest("general", General)

) ;

}
}
